package ClassExerciseMaxProfit;

// an interface for encapsulating a max-profit algorithm
// so that we can pass the relevant max-profit algorithm/procedure 
// as a parameter to a method
public interface IMaxProfitAlgorithm {
	
	public String getAlgoDescription();
	
	// compute max profit given an integer of share prices
	public int computeMaxProfit(int [] prices);
	
	// Q: checking whether the inclusion of toString() here necessitates 
	// supplying a toString method in an implementation of the interface
	// public String toString();
	// A: No. we can un-comment the line above, without implementing toString
	// and it will work fine
}
	