package ClassExerciseMaxProfit;

// This class gives two solutions to questions 1 in
// the exam of Semester A, Fall 2010-11:
// Given an array prices (for share prices) of integers 
// find the maximum number prices[j]-prices[i], where j>i

// this is the basic library file that contains the two algorithms: 
// a linear time algorithm and a quadratic time algorithm 

public class MaxProfit {
	
	// inefficient, quadratic-time algorithm
	// pre: the array prices has at least two entries
	public static int maxProfitByTwoLoops(int [] prices) {
      int profit = prices[1] - prices[0];
        
      // check all combinations of buying value prices[i] 
      // and selling value prices[j] 
      for (int i=0; i < prices.length-1; i++) {
      	for (int j=i+1; j < prices.length; j++) {
       	int tempProfit = prices[j]-prices[i];
       	profit = tempProfit > profit ? tempProfit : profit;
       	}
      }
      return profit;
	}
	
	// efficient, linear-time algorithm
    // pre: the array prices has at least two entries
	public static int maxProfitByOneLoop(int [] prices) {
      
		int profit = prices[1] - prices[0];
		int lowestBuy = prices[0] < prices[1] ? prices[0] : prices[1];
		
		if (prices.length == 2) {
			return profit;
		}
        
      // three or more items in prices[]: proceed incrementally
      for (int i=2; i < prices.length; i++) {
       	int tempProfit = prices[i]-lowestBuy;
       	profit = tempProfit > profit ? tempProfit : profit;
       	lowestBuy = lowestBuy < prices[i] ? lowestBuy : prices[i];
       	}
      return profit;
	}
	
	// a simple test main
	public static void main(String args[]) {

		// all numbers are positive integers
        int[] prices = {13,11,14,19,20,2,5,100,300};
                      
    	System.out.println("two loops method, max profit is: "+maxProfitByTwoLoops(prices));
    	System.out.println("one loop  method, max profit is: "+maxProfitByOneLoop(prices));

	}
}
