package ClassExerciseMaxProfit;

import java.util.Random;

// utilities for testing the class MaxProfit
//(see more about the problem in the Class MaxProfit) 
//including
//randInt: a method to obtain a new random integer
//fillInIntArray: a method that does just that
//printIntArray

public class MaxProfitUtils {

	/**
	 * <taken from stackoverflow.com>
	 * Returns a psuedo-random number between min and max, inclusive.
	 * The difference between min and max can be at most
	 * <code>Integer.MAX_VALUE - 1</code>.
	 *
	 * @param min Minimim value
	 * @param max Maximim value.  Must be greater than min.
	 * @return Integer between min and max, inclusive.
	 * @see java.util.Random#nextInt(int)
	 */
	public static int randInt(int min, int max) {

	    // Usually this can be a field rather than a method variable
	    Random rand = new Random();

	    // nextInt is normally exclusive of the top value,
	    // so add 1 to make it inclusive
	    int randomNum = rand.nextInt((max - min) + 1) + min;

	    return randomNum;
	}
	
	public static void fillInIntArray(int[] a, int length, int min, int max) {

	    for (int i=0; i<length; i++) {
	    	a[i] = randInt(min,max);
	    }
	}
	
	public static void printIntArray(int[] a) {
		
		System.out.println("printing and inetgeer array of length "+a.length);
		
	    for (int i=0; i < a.length; i++) {
	    	System.out.print(a[i]+" ");
	    	if ((i+1) % 10 == 0) {
	    		System.out.println("");
	    	}
	    }
	}

}
