package ClassExerciseMaxProfit;

// the new version of the test class, using interface

// a test class for the class MaxProfit
// (see more about the problem in the Class MaxProfit) 
// the main compares two different algorithms for 
// computing maxProfit using standard timing methods
public class TestMaxProfitWithInterface {
	
	public static void computeAndPrint(IMaxProfitAlgorithm funcObj, int [] prices) {

        long startTime = System.currentTimeMillis();
    	System.out.print(funcObj.getAlgoDescription()+ ", max profit is: "+funcObj.computeMaxProfit(prices));
    	System.out.println(", in "+(System.currentTimeMillis()-startTime)+" millis");

	}
	public static void main(String args[]) {

		final int numberOfDays=1000;
		// all numbers are positive integers
        int[] prices = new int[numberOfDays];
        
        MaxProfitUtils.fillInIntArray(prices,numberOfDays,1,1000);
        MaxProfitUtils.printIntArray(prices);
        System.out.println();
        
        computeAndPrint(new MaxProfitLinearTimeAlgorithm(), prices);

        computeAndPrint(new MaxProfitQuadraticTimeAlgorithm(), prices);
        
	}
}
